<?php
/*
Description: Adds nivoSlider support to the i18n_gallery plugin for GetSimple CMS
Version: 0.9.3
Author: Alexander Amatuni
*/
i18n_gallery_register('nivoSlider', 'nivoSlider', 
  '<strong>NivoSlider</strong> is a responsive and very customizable JQuery slider.<br/>Javascript MUST be enabled.<br/>'.
  'Licensed under MIT<br/>'.
  '<a href="http://dev7studios.com/plugins/nivo-slider/" target="_blank">http://dev7studios.com/plugins/nivo-slider/</a>',
  'i18n_gallery_nivoSlider_edit', 'i18n_gallery_nivoSlider_header', 
  'i18n_gallery_nivoSlider_content');

function i18n_gallery_nivoSlider_edit($gallery) {
?><h2>Appearance</h2>
  <p>
    <label for="nivoSlider-theme"><?php i18n('i18n_gallery/THEME'); ?></label>
    <select class="text" name="nivoSlider-theme">
      <option value="bar"     <?php echo @$gallery['theme'] == 'bar'     ? 'selected="selected"' : ''; ?>> bar     </option>
      <option value="dark"    <?php echo @$gallery['theme'] == 'dark'    ? 'selected="selected"' : ''; ?>> dark    </option>
      <option value="default" <?php echo @$gallery['theme'] == 'default' ? 'selected="selected"' : ''; ?>> default </option>
      <option value="light"   <?php echo @$gallery['theme'] == 'light'   ? 'selected="selected"' : ''; ?>> light   </option>
      <option value="nano"    <?php echo @$gallery['theme'] == 'nano'    ? 'selected="selected"' : ''; ?>> nano    </option>
    </select>
  </p>
  <p class="inline">
    <label class="inline" for="nivoSlider-effect"><?php i18n('i18n_gallery/EFFECT'); ?></label>
    <select class="text" name="nivoSlider-effect" id="nivoSlider-effect" style="width:10em">
      <option value="random"             <?php echo @$gallery['effect'] == 'random'             ? 'selected="selected"' : ''; ?>> random             </option>
      <option value="sliceDown"          <?php echo @$gallery['effect'] == 'sliceDown'          ? 'selected="selected"' : ''; ?>> sliceDown          </option>
      <option value="sliceDownLeft"      <?php echo @$gallery['effect'] == 'sliceDownLeft'      ? 'selected="selected"' : ''; ?>> sliceDownLeft      </option>
      <option value="sliceUp"            <?php echo @$gallery['effect'] == 'sliceUp'            ? 'selected="selected"' : ''; ?>> sliceUp            </option>
      <option value="sliceUpLeft"        <?php echo @$gallery['effect'] == 'sliceUpLeft'        ? 'selected="selected"' : ''; ?>> sliceUpLeft        </option>
      <option value="sliceUpDown"        <?php echo @$gallery['effect'] == 'sliceUpDown'        ? 'selected="selected"' : ''; ?>> sliceUpDown        </option>
      <option value="sliceUpDownLeft"    <?php echo @$gallery['effect'] == 'sliceUpDownLeft'    ? 'selected="selected"' : ''; ?>> sliceUpDownLeft    </option>
      <option value="fold"               <?php echo @$gallery['effect'] == 'fold'               ? 'selected="selected"' : ''; ?>> fold               </option>
      <option value="fade"               <?php echo @$gallery['effect'] == 'fade'               ? 'selected="selected"' : ''; ?>> fade               </option>
      <option value="slideInRight"       <?php echo @$gallery['effect'] == 'slideInRight'       ? 'selected="selected"' : ''; ?>> slideInRight       </option>
      <option value="slideInLeft"        <?php echo @$gallery['effect'] == 'slideInLeft'        ? 'selected="selected"' : ''; ?>> slideInLeft        </option>
      <option value="boxRandom"          <?php echo @$gallery['effect'] == 'boxRandom'          ? 'selected="selected"' : ''; ?>> boxRandom          </option>
      <option value="boxRain"            <?php echo @$gallery['effect'] == 'boxRain'            ? 'selected="selected"' : ''; ?>> boxRain            </option>
      <option value="boxRainReverse"     <?php echo @$gallery['effect'] == 'boxRainReverse'     ? 'selected="selected"' : ''; ?>> boxRainReverse     </option>
      <option value="boxRainGrow"        <?php echo @$gallery['effect'] == 'boxRainGrow'        ? 'selected="selected"' : ''; ?>> boxRainGrow        </option>
      <option value="boxRainGrowReverse" <?php echo @$gallery['effect'] == 'boxRainGrowReverse' ? 'selected="selected"' : ''; ?>> boxRainGrowReverse </option>
    </select>
  </p>
  <p class="inline">
    <label for="nivoSlider-slices">Slices</label>
    <input type="text" class="text" id="nivoSlider-slices" name="nivoSlider-slices" value="<?php echo @$gallery['slices']; ?>" style="width:2em"/>     
  </p>
  <p class="inline"> 
    <label for="nivoSlider-slices" id="nivoSlider-box-label">Boxes cols x rows</label>
    <input type="text" class="text" id="nivoSlider-boxCols" name="nivoSlider-boxCols" value="<?php echo @$gallery['boxCols']; ?>" style="width:2em"/>
    <input type="text" class="text" id="nivoSlider-boxRows" name="nivoSlider-boxRows" value="<?php echo @$gallery['boxRows']; ?>" style="width:2em"/> 
  </p>
  <hr/>
  <h2>Navigation</h2>
  <p class="inline"> 
    <label for="nivoSlider-disableDirectionNav">Disable direction control (prev & next) </label>
    <input type="checkbox" id="nivoSlider-disableDirectionNav" name="nivoSlider-disableDirectionNav" value="1" <?php echo @$gallery['disableDirectionNav'] ? 'checked="checked"' : ''; ?>></input>

    <label for="nivoSlider-prevText">"Prev" text</label>
    <input type="text" class="text" id="nivoSlider-prevText" name="nivoSlider-prevText" value="<?php echo @$gallery['prevText'] ?>" style="width:5em"></input>

    <label for="nivoSlider-prevText">"Next" text</label>   
    <input type="text" class="text" id="nivoSlider-nextText" name="nivoSlider-nextText" value="<?php echo @$gallery['nextText'] ?>" style="width:5em"/>   
    <br/>
    <label for="nivoSlider-disablePagination">Disable pagination</label>
    <input type="checkbox" id="nivoSlider-disablePagination" name="nivoSlider-disablePagination" value="1" <?php echo @$gallery['disablePagination'] ? 'checked="checked"' : ''; ?>/>    
    
    <label for="nivoSlider-paginationThumbs">Use thumbs for pagination</label>     
    <input type="checkbox" id="nivoSlider-paginationThumbs" name="nivoSlider-paginationThumbs" value="1" <?php echo @$gallery['paginationThumbs'] ? 'checked="checked"' : ''; ?> />
  </p>  
  <hr/>
  <h2>Starting slide</h2>
  <p>
    <label for="nivoSlider-randomStart">Start from random slide</label>
    <input type="checkbox" id="nivoSlider-randomStart" name="nivoSlider-randomStart" value="1" <?php echo @$gallery['randomStart'] ? 'checked="checked"' : ''; ?> />
    <label for="nivoSlider-startSlide">Start from slide</label>
    <select class="text" name="nivoSlider-startSlide" id="nivoSlider-startSlide">
<?php 
  $count = count($gallery['items']);
  for ($i=0; $i<$count; $i++) {
    $item = $gallery['items'][$i]; 
?>
  <option value="<?php echo $i; ?>" ><?php echo $item['filename']; ?></option>
<?php
}
?>    
    </select>
  </p>
  <hr/>
  <h2>Delays</h2>
  <p class="inline">
    <label for="nivoSlider-manualAdvance">Manual advance</label>
    <input type="checkbox" id="nivoSlider-manualAdvance" name="nivoSlider-manualAdvance" value="1" <?php echo @$gallery['manualAdvance'] ? 'checked="checked"' : ''; ?> />

    <label for="nivoSlider-interval"><?php i18n('i18n_gallery/INTERVAL'); ?></label>
    <input type="text" class="text" id="nivoSlider-interval" name="nivoSlider-interval" value="<?php echo @$gallery['interval']; ?>" style="width:3em"/>

    <label for="nivoSlider-pauseOnHover">Pause on hover</label>
    <input type="checkbox" id="nivoSlider-pauseOnHover" name="nivoSlider-pauseOnHover" value="1" <?php echo @$gallery['pauseOnHover'] ? 'checked="checked"' : ''; ?> />
    <br/>
    <label for="nivoSlider-slices">Anim speed, msec</label>
    <input type="text" class="text" name="nivoSlider-animSpeed" value="<?php echo @$gallery['animSpeed']; ?>" style="width:3em"/>
  </p>

  
  <script type="text/javascript">
    function changeNivosliderEffectDependentParameters() {
        var showSlice = $('#nivoSlider-effect option:selected').text().indexOf('slice') > -1;
        if (showSlice) $('#nivoSlider-slices').show().prev().show(); else $('#nivoSlider-slices').val('15').hide().prev().hide();
        
        var showBox = $('#nivoSlider-effect option:selected').text().indexOf('box') > -1;
        if (showBox) {
          $('#nivoSlider-box-label').show();
          $('#nivoSlider-boxCols').show();
          $('#nivoSlider-boxRows').show();
        } else {
          $('#nivoSlider-box-label').hide();
          $('#nivoSlider-boxCols').val('8').hide();
          $('#nivoSlider-boxRows').val('4').hide();
        }
    }
    
    function changeNivoSliderAdvanceParameters() {
      var manual = $('#nivoSlider-manualAdvance:checked').size() > 0;
      $('#nivoSlider-interval').attr('disabled', manual);
      $('#nivoSlider-pauseOnHover').attr('disabled', manual);
    }
    
    function changeNivoSliderStartParameters() {
      $('#nivoSlider-startSlide').attr('disabled', $('#nivoSlider-randomStart:checked').size() > 0);
    }
    
    function changeNivoSliderDirectionParameters() {
      var nextPrev = $('#nivoSlider-disableDirectionNav:checked').size() > 0;
      $('#nivoSlider-prevText').attr('disabled', nextPrev);
      $('#nivoSlider-nextText').attr('disabled', nextPrev);    
    }
    
    function changeNivoSliderPaginationParameters() {
      var th = $('#nivoSlider-disablePagination:checked').size() > 0;
      $('#nivoSlider-paginationThumbs').attr('disabled', th);
      if (th) $('#nivoSlider-paginationThumbs').attr('checked', false);
    }
    
    $(function() {
      $('#nivoSlider-effect').change(changeNivosliderEffectDependentParameters);
      $('#nivoSlider-manualAdvance').click(changeNivoSliderAdvanceParameters);
      $('#nivoSlider-randomStart').click(changeNivoSliderStartParameters);
      $('#nivoSlider-disableDirectionNav').click(changeNivoSliderDirectionParameters);
      $('#nivoSlider-disablePagination').click(changeNivoSliderPaginationParameters);
      changeNivosliderEffectDependentParameters();
      changeNivoSliderAdvanceParameters();
      changeNivoSliderStartParameters();
      changeNivoSliderDirectionParameters();
      changeNivoSliderPaginationParameters();
    });
  </script>      
<?php
  }

function i18n_gallery_nivoSlider_header($gallery) {
  global $SITEURL;
  if (i18n_gallery_check($gallery,'jquery') && i18n_gallery_needs_include('jquery.js')) {
?>
    <script src="//ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js"></script>
<?php
  }
  if (i18n_gallery_check($gallery,'js') && i18n_gallery_needs_include('jquery.nivo.slider.pack.js')) {
?>
    <script type="text/javascript" src="<?php echo $SITEURL; ?>plugins/i18n_gallery/js/jquery.nivo.slider.js"></script>
<?php
  } 
  if (i18n_gallery_check($gallery,'css') && i18n_gallery_needs_include('nivo-slider.css')) {
?> 
  <link rel="stylesheet" href="<?php echo $SITEURL; ?>plugins/i18n_gallery/css/nivo-slider.css"/>
  
<?php } ?>
  <link rel="stylesheet" href="<?php echo $SITEURL; ?>plugins/i18n_gallery/css/nivo-slider-<?php echo @$gallery['theme']; ?>.css"/>
  <script type="text/javascript">
  $(window).load(function() {
    $('#nivoSlider-<?php echo i18n_gallery_id($gallery) ?>').nivoSlider({
          effect: '<?php echo @$gallery['effect']; ?>',               
          slices: <?php echo intval(@$gallery['slices']) == 0 ? 15 : intval(@$gallery['slices']); ?>,    
          boxCols: <?php echo intval(@$gallery['boxCols']) == 0 ? 8 : intval(@$gallery['boxCols']); ?>,                     
          boxRows: <?php echo intval(@$gallery['boxRows']) == 0 ? 4 : intval(@$gallery['boxRows']); ?>,
          
          manualAdvance: <?php echo @$gallery['manualAdvance'] ? 'true' : 'false'; ?>,
          pauseTime: <?php echo intval(@$gallery['interval']) == 0 ? 3000 : intval(@$gallery['interval']); ?>,
          pauseOnHover: <?php echo @$gallery['pauseOnHover'] ? 'true' : 'false'; ?>,             
          animSpeed: <?php echo intval(@$gallery['animSpeed']) == 0 ? 500 : intval(@$gallery['animSpeed']); ?>,
          
          startSlide: <?php echo is_null (@$gallery['startSlide']) ? 0: @$gallery['startSlide']; ?>,       
          randomStart: <?php echo @$gallery['randomStart'] ? 'true' : 'false'; ?>,
          
          directionNav: <?php echo @$gallery['disableDirectionNav'] ? 'false' : 'true'; ?>, 
          prevText: '<?php echo (trim(@$gallery['prevText']) == NULL) ? 'Prev' : trim(@$gallery['prevText']); ?>', 
          nextText: '<?php echo (trim(@$gallery['nextText']) == NULL) ? 'Next' : trim(@$gallery['nextText']); ?>',
          controlNav: <?php echo @$gallery['disablePagination'] ? 'false' : 'true'; ?>, 
          controlNavThumbs: <?php echo @$gallery['paginationThumbs'] ? 'true' : 'false'; ?>
        })
    });

  </script>  
<?php
}

function i18n_gallery_nivoSlider_content($gallery) {
?>
  <div class="slider-wrapper theme-<?php echo @$gallery['theme']; ?>">
    <div class="ribbon"></div>
      <div id="nivoSlider-<?php echo i18n_gallery_id($gallery) ?>" class="nivoSlider">
<?php 
  $count = count($gallery['items']);
  for ($i=0; $i<$count; $i++) {
    $item = $gallery['items'][$i]; 
    $descr = @$item['_description'];    
?>  
      <img src="<?php i18n_gallery_image_link($gallery,$item); ?>" alt="" title="<?php echo $descr;?>"  
      <?php if (@$gallery['paginationThumbs']) { ?>
        data-thumb="<?php i18n_gallery_thumb_link($gallery,$item); ?>"
      <?php
      }?>
      />
      
<?php } ?>
    </div>
  </div>
<?php
} 